// Mark Bowers - Oakland University
// HCS12 VGA - rev 1
// http://markbowers.org/home/hcs12-vga

#include <hidef.h>      /* common defines and macros */
#include "derivative.h"      /* derivative-specific definitions */

#include "main_asm.h" /* interface to the assembly module */

#include "letters.h"


char video_buffer_A[60][80];
char video_buffer_B[60][80];
// 80 pixels wide, 60 pixels high
// total length = 4800 = 4.8kB

const char red     = 0b00000100;
const char green   = 0b00000010;
const char blue    = 0b00000001;
const char cyan    = 0b00000110;
const char magenta = 0b00000101;
const char yellow  = 0b00000011; 
const char white   = 0b00000111;
const char black   = 0b00000000;

char colors[6] = {
  red, green, blue, cyan, magenta, yellow
};

char mask_color(char bit, char line, char color, char bg){
  char mask = 0x01;
  bit = 7 - bit;
  mask = mask << bit;
  
  if (mask & line)
    return color;
  else
    return bg;
}

void rot_colors(void) {
  char temp = colors[5];
  colors[5] = colors[4];
  colors[4] = colors[3];
  colors[3] = colors[2];
  colors[2] = colors[1];
  colors[1] = colors[0];
  colors[0] = temp;
}

void paint_colors_A(void){
int i;
int j;

 for (i = 0; i<80; i++){
    for (j = 0; j<6; j++){
    video_buffer_A[j][i] = colors[j];
    video_buffer_A[59-j][i] = colors[j];
    }
    for (j = 6; j<12; j++){
    video_buffer_A[j][i] = colors[j-6];
    video_buffer_A[59-j][i] = colors[j-6];
    }
 }
 
}


void paint_colors_B(void){
int i;
int j;

 for (i = 0; i<80; i++){
    for (j = 0; j<6; j++){
    video_buffer_B[j][i] = colors[j];
    video_buffer_B[59-j][i] = colors[j];
    }
    for (j = 6; j<12; j++){
    video_buffer_B[j][i] = colors[j-6];
    video_buffer_B[59-j][i] = colors[j-6];
    }
 }
 
}


void write(char row, char col, char* letter, char color){
char i = 0;
char j = 0;
char bg;

     for (j = col; j<8+col; j++){
          for (i = row; i<9+row; i++){ 
          bg = video_buffer_A[i][j];     
          video_buffer_A[i][j] = mask_color(j-col, letter[i-row], color, bg);
          bg = video_buffer_B[i][j];     
          video_buffer_B[i][j] = mask_color(j-col, letter[i-row], color, bg);

     }
    } 
  }




void interrupt 26 handler(){
MCFLG = 0x80;   // clear interrupt flag
//PTH = ~PTH;     // test interrupt period
video_draw();   // video routine
}



void main(void) {
int i;
int j;
char counter;
char toggle = 0xFF;

// EnableInterrupts;
 PLL_setup();
 
 seg7dec(0x00);


// intialize buffer
 for (i = 0; i<80; i++){
     for (j = 0; j<60; j++){
     //     if (j % 2)  
            video_buffer_A[j][i] = white;
            video_buffer_B[j][i] = white;
     //     else
     //       display_buffer[j][i] = 0x00;
     }
 }
 
 paint_colors_A();

//letter = a;


write(19,15+2,    &H, black);
write(19,15+2+9,  &C, black);
write(19,15+2+9+9, &S, black);
write(19,15+2+9+9+9, &one, black);
write(19,15+2+9+9+9+9, &two, black); 

write(19+13,15+11,    &V, red);
write(19+13,15+11+9,  &G, green);
write(19+13,15+11+9+9, &A, blue);
 
 set_video_pointer(&video_buffer_A[0][0]);
 
 video_enable();

// seg7dec(0x01); 

// asm_main(); /* call the assembly function */

 DDRH = 0xFF;

  for(;;) {
      counter++;
      seg7dec(counter&0x0F);
      ms_delay(5);
      if (toggle) {
          toggle = ~toggle;
          rot_colors();
          paint_colors_A();
          set_video_pointer(&video_buffer_A[0][0]);
      }else{
          toggle = ~toggle;
          rot_colors();
          paint_colors_B();
          set_video_pointer(&video_buffer_B[0][0]);      
          }

      

  
  
 //   _FEED_COP(); /* feeds the dog */
  } /* loop forever */
  /* please make sure that you never leave main */
}
